//  RandomStringPresenterAppDelegate.m
//  RandomStringPresenter

#import "RandomStringPresenterAppDelegate.h"

#include <fstream>
#include <iostream>
#include <string>
#include <vector>

class quotes_t
{
	std::vector<std::string>	_quotes;
	
public:
	quotes_t()
	{}

	~quotes_t()
	{
		while ( !_quotes.empty() )
		{
			_quotes.pop_back();
		}
	}

	void init(const std::string& strPathname)
	{
		using std::getline;
		using std::ifstream;
		using std::string;
		
		ifstream	ifs(strPathname.c_str());
		if ( ifs.is_open() )
		{
			string	str;
			while ( getline(ifs, str) )
			{
				_quotes.push_back(str);
			}
		}
	}

	const std::string& randomQuote()
	{
		return _quotes.at(random() % _quotes.size());
	}
};


@implementation RandomStringPresenterAppDelegate

@synthesize window;

-(void)applicationDidFinishLaunching:(NSNotification*)aNotification
{
	using std::string;

	srand(time(NULL));
	
	string	strPath		= [[[NSBundle mainBundle] resourcePath] cStringUsingEncoding:NSASCIIStringEncoding];
	string	strPathname	= strPath + "/Spick Quotes.txt";

	quotes = new quotes_t;
	quotes->init(strPathname);
}

-(void)applicationWillTerminate:(NSNotification*)notification
{
	delete quotes;
}

-(IBAction)speak:(id)sender
{
	[spoken setStringValue:[NSString stringWithUTF8String:quotes->randomQuote().c_str()]];
}

@end
